//Copyright (c) 2006, Tarn Adams
//All rights reserved.  See game.cpp or license.txt for more information.

#include <windows.h>
#include <string.h>
#include <math.h>
#include <iosfwd>
#include <iostream>
#include <ios>
#include <streambuf>
#include <istream>
#include <ostream>
#include <iomanip>
#include <sstream>
#include <cstdlib>
#include <fstream>
#include "zlib/zlib.h"

#include "svector.h"
using std::string;

#include "random.h"

#include "files.h"

#include "enabler.h"

//this is from zlib examples and is used by the compressor
#define CHECK_ERR(err, msg) { \
	if (err != Z_OK) {\
	char str[80]; \
	strcpy(str,msg);\
	strcat(str," error: ");\
	char num[20];\
	itoa(err,num,10);\
	strcat(str,num);\
	MessageBox(NULL,str,0,0); \
	exit(1);\
	}\
	}

//#pragma warning( 3 : 4189 )

#include "graphics.h"

#include "music_and_sound_g.h"

#include "basics.h"

#include "definition.h"

#include "critter.h"

#include "kobold.h"

#include "adventurer.h"

#include "unit.h"

#include "cave.h"

#include "interface.h"

#include "init.h"

#include "command_line.h"

class gamest
{
	public:
		definition_handlerst definition;
		command_linest command_line;
		main_interfacest main_interface;

		long next_text_id;

		cavest cave;

		unit_handlerst unit;
		long next_unit_id;

		kobold_handlerst kobold;
		long next_kobold_id;

		adventurer_handlerst adventurer;
		long next_adventurer_id;

		critter_handlerst critter;
		long next_critter_id;

		long selected_kobold;
		
		char pass_turn;
		long reprieve_time;
		long cur_sound;
		long cur_sound_priority;

		gamest()
			{
			next_text_id=TEXTNUM;
			}

		void end_game();
		void clean();
		void load_option_files();
		void print();
		void load_score_list();
		void save_score_list();
		void create_initial_kobolds();
		void turn();
		void create_adventurer_wave();
		void move_critters();
		void move_adventurers();
		void input();
		void save_active_game();
		char load_active_game();
		void write_file(file_compressorst &filecomp);
		void read_file(file_compressorst &filecomp,long loadversion);
		void set_sound(long s);
		void play_sound(long s);
};